#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    int a[n];
    for (int i=0; i<n; i++) {
        cin >> a[i];
    }
    int c=0;
    vector <pair<int,int>> p;
    for (int i=0; i<n; i++) {
        for (int j=0; j<n-i; j++) {
            if (a[j]>a[j+1]) {
                c++;
                swap(a[j],a[j+1]);
                p.push_back({j+1,j+2});
            }
        }
    }
    cout << c << endl;
    for (int i=0; i<p.size(); i++) {
        cout << p[i].first << " " << p[i].second << endl;
    }

}
